Name: libstdcplusplus
Version     : 6.3.0
Release: 5
%define toolbox_release 1
%if 0%{?ibmi_version} < 72
%define aix_version 6.1
%else
%define aix_version 7.1
%endif
Group       : Development/Libraries
License     : GPLv3
URL         : http://gcc.gnu.org/
Summary     : GNU Standard C++ Library

Requires    : lib:/QOpenSys/pkgs/lib/libgcc_s.a(shr.o)(ppc)
Requires    : lib:/QOpenSys/pkgs/lib/libgcc_s.a(shr.o)(ppc64)

BuildRequires: cpio-gnu
BuildRequires: ibm-build-tools

Source0: https://public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc-%{aix_version}/gcc/libstdcplusplus-%{version}-%{toolbox_release}.aix%{aix_version}.ppc.rpm
Source1: https://public.dhe.ibm.com/aix/freeSoftware/aixtoolbox/RPMS/ppc-%{aix_version}/gcc/libstdcplusplus-devel-%{version}-%{toolbox_release}.aix%{aix_version}.ppc.rpm

%description
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

%package aix
Summary: AIX Toolbox C++ compatibility libraries
BuildArch: fat

%description aix
Provides libstdc++.a


%package -n libstdcplusplus6
Summary: GNU Standard C++ Library

%description -n libstdcplusplus6
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library.

%package -n libstdcplusplus-devel
Summary: Development files for libstdc++6
Requires: libstdcplusplus6 = %{version}

%description -n libstdcplusplus-devel
Development files for libstdc++6

%install
mkdir %{buildroot}/tmp
cd %{buildroot}/tmp

rpm2cpio %{SOURCE0} | cpio -idmv

mkdir -p $(dirname %{buildroot}/%{_docdir})
mkdir -p %{buildroot}/%{_libdir}

cd %{buildroot}/%{_libdir}

mkdir 32 64
cd 32
    ar -X32 x %{buildroot}/tmp/opt/freeware/lib/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/libstdc++.a
    fix-rpath libstdc++.so.6 %{_libdir}:/QOpenSys/usr/lib
cd ../64
    ar -X64 x %{buildroot}/tmp/opt/freeware/lib/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/libstdc++.a
    fix-rpath libstdc++.so.6 %{_libdir}:/QOpenSys/usr/lib
cd ..

cp 64/libstdc++.so.6 .
svr4-shrlib libstdc++.so.6 libstdc++.so.6 ppc64
ln -s libstdc++.so.6 libstdc++.so

strip -X32 -e 32/libstdc++.so.6
strip -X64 -e 64/libstdc++.so.6
ar -X32_64 crlo libstdc++.a 32/libstdc++.so.6 64/libstdc++.so.6

rm -r 32 64

cd %{buildroot}/tmp
rm -r ./opt/freeware/lib/gcc


rpm2cpio %{SOURCE1} | cpio -idmv

mv ./opt/freeware/lib/gcc %{buildroot}%{_libdir}
find %{buildroot}%{_libdir}/gcc -name \*.la | xargs rm

mv ./opt/freeware/doc %{buildroot}/%{_docdir}

%if 0%{?ibmi_version} < 72
# Fix up PASE 7.1 doesn't have these errno values defined
perl -p -i -e 's|#define _GLIBCXX_HAVE_ENOTRECOVERABLE 1|/* undef _GLIBCXX_HAVE_ENOTRECOVERABLE */|' \
  %{buildroot}%{_libdir}/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/include/c++/powerpc-ibm-aix%{aix_version}.0.0/bits/c++config.h \
  %{buildroot}%{_libdir}/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/include/c++/powerpc-ibm-aix%{aix_version}.0.0/ppc64/bits/c++config.h \
  %{buildroot}%{_libdir}/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/include/c++/powerpc-ibm-aix%{aix_version}.0.0/pthread/bits/c++config.h \
  %{buildroot}%{_libdir}/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/include/c++/powerpc-ibm-aix%{aix_version}.0.0/pthread/ppc64/bits/c++config.h

perl -p -i -e 's|#define _GLIBCXX_HAVE_EOWNERDEAD 1|/* undef _GLIBCXX_HAVE_EOWNERDEAD */|' \
  %{buildroot}%{_libdir}/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/include/c++/powerpc-ibm-aix%{aix_version}.0.0/bits/c++config.h \
  %{buildroot}%{_libdir}/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/include/c++/powerpc-ibm-aix%{aix_version}.0.0/ppc64/bits/c++config.h \
  %{buildroot}%{_libdir}/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/include/c++/powerpc-ibm-aix%{aix_version}.0.0/pthread/bits/c++config.h \
  %{buildroot}%{_libdir}/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}/include/c++/powerpc-ibm-aix%{aix_version}.0.0/pthread/ppc64/bits/c++config.h
%endif

cd %{buildroot}
rm -r %{buildroot}/tmp

rm -r %{buildroot}%{_docdir}/libstdc++-devel-%{version} || :

%files aix
%defattr(-, qsys, *none)

%{_libdir}/libstdc++.a

%files -n libstdcplusplus6
%defattr(-, qsys, *none)

%{_libdir}/libstdc++.so.6

%files -n libstdcplusplus-devel
%defattr(-, qsys, *none)

%{_libdir}/libstdc++.so
%{_libdir}/gcc/powerpc-ibm-aix%{aix_version}.0.0/%{version}

%{_docdir}/libstdc++-%{version}

%changelog
